"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeActivator = void 0;
var makeActivator = function (dependsOn, activator) {
    if (!dependsOn) {
        return activator;
    }
    if (!activator) {
        return function (options) {
            return dependsOn.reduce(function (acc, trait) { return acc && (!trait.activator || trait.activator(options)); }, true);
        };
    }
    return function (options) {
        return dependsOn.reduce(function (acc, trait) { return acc && (!trait.activator || trait.activator(options)); }, true) && activator(options);
    };
};
exports.makeActivator = makeActivator;
