"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeTraits = void 0;
var lodash_last_1 = __importDefault(require("lodash.last"));
var depth_dependencies_helper_1 = require("./depth-dependencies.helper");
var is_dependent_on_helper_1 = require("./is-dependent-on.helper");
var dependenciesCount = function (trait) {
    var _a, _b, _c, _d;
    return ((_b = (_a = trait.dependsOn) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) +
        ((_d = (_c = trait.dependsOn) === null || _c === void 0 ? void 0 : _c.reduce(function (acc, trait) { return acc + dependenciesCount(trait); }, 0)) !== null && _d !== void 0 ? _d : 0);
};
var normalizeTraits = function (traits, options) {
    var _a;
    var treatedTraits = traits
        .filter(function (trait) { return !trait.activator || trait.activator(options); })
        .flatMap(function (trait) { return __spreadArray([trait], (0, depth_dependencies_helper_1.depthDependencies)(trait), true); })
        .filter(function (trait, index, self) {
        return self.findIndex(function (x) { return x.uniqueId === trait.uniqueId; }) === index;
    })
        .sort(function (a, b) {
        if ((0, is_dependent_on_helper_1.isDependentOn)(a, b))
            return 1;
        if ((0, is_dependent_on_helper_1.isDependentOn)(b, a))
            return -1;
        if (a.abstract && !b.abstract)
            return -1;
        if (b.abstract && !a.abstract)
            return 1;
        return dependenciesCount(a) - dependenciesCount(b);
    });
    if ((_a = (0, lodash_last_1.default)(treatedTraits)) === null || _a === void 0 ? void 0 : _a.abstract) {
        throw new Error("The last trait in the list cannot be abstract");
    }
    return treatedTraits;
};
exports.normalizeTraits = normalizeTraits;
